QGIS Application - Bug report #21380
WFS GET requests default to using "hostname:80' in the host header instead of just "hostname”
2019-02-25 07:27 PM - Lilah R

Status: Rejected

Priority: Normal

Assignee:

Category: Web Services clients/WFS

Affected QGIS version:3.6.0 Regression?: No
Operating System: Windows Easy fix?: Yes
Pull Request or Patch supplied: Resolution: invalid
Crashes QGIS or corrupls data: Copied to github as #: 29197
Description

| spent the evening trying to figure out why the Lazio regional WFS server (http://geoportale.regione.lazio.it/geoserver_nsit/wfs) was
throwing a 403 forbidden error whenever | tried to connect via QGIS, but responding normally when | tried to connect to it in any other
way. It turns out that QGIS adds a :80 to the hostname of a server, and that this particular WFS server refuses connections that include

the port number in the header. | don't know why this would be, but it's pretty unusual. Neither Firefox nor WGET add :80 to the HOST line
in their HTTP GET requests. Ideally, QGIS would default to not including the port number and assuming the server will default to port 80,
but if that would break things, then perhaps at least there could be an override option to send a GET request without including the port
number.

History

#1 - 2019-02-25 10:21 PM - Alessandro Pasotti

- Resolution set to invalid

- Status changed from Open to Rejected

QGIS honours the capabilities sent by the server:

http://geoportale.regione.lazio.it/geoserver nsit/wfs/?REQUEST=GetCapabilities&#38;SERVICE=WFS

<ows:Get xlink:href="http://geoportale.regione.lazio.it:80/geoserver_nsit/wfs"/>

#2 - 2019-03-21 12:45 PM - Andrea Giudiceandrea

Lilah R, you can override the "wrong" GetMap URI provided in the capabilities, using the option "Ignore GetMap/GetTile URI reported in capabilities" (and
"Ignore GetFeaturelnfo URI reported in capabilities” if needed) in the "WMS/WMTS Options" section of the "Create a New WMS/WMTS Connection”
dialog window.

See also http://osgeo-org.1560.x6.nabble.com/Servizio-WMS-del-SIT-Regione-Lazio-su-QGIS-Considerazioni-varie-td5399043.html for the same problem

with the geoportale.regione.lazio.it WMS.

#3 - 2019-03-21 12:49 PM - Alessandro Pasotti

Wasn't this issue for WFS?

#4 - 2019-03-21 04:53 PM - Andrea Giudiceandrea
http://geoportale.regione.lazio.it/geoserver_nsit/wfs
http://geoportale.regione.lazio.it/geoserver_nsit/wfs/?REQUEST=GetCapabilities&#38;SERVICE=WFS
http://osgeo-org.1560.x6.nabble.com/Servizio-WMS-del-SIT-Regione-Lazio-su-QGIS-Considerazioni-varie-td5399043.html

You are right Alessandro, | got confused...
So it seems the WFS connection manager lacks an option to override the (GetFeature, DescribeFeatureType, ...) URIs reported in capabilities, while
WMS/WMTS and WCS connection managers have that option ("Ignore GetMap/GetTile URI reported in capabilities"/"Ignore GetFeaturelnfo URI reported

in capabilities" for WMS/WMST and "Ignore GetCoverage URI reported in capabilities" for WCS).

It's the opposite of Bug reports #18099 and #16173 that you fixed for QGIS 3 with PR https:/github.com/qgis/QGIS/pull/6407

In fact, with QGIS 2.18 the WFS at http://geoportale.regione.lazio.it/geoserver_nsit/wfs works without throwing the 403 forbidden error.

It would be nice to have a DCP override option for WFS too. This could be a feature request...
